summaryrefslogtreecommitdiff
path: root/r-base/backport_r-base_to_etch.sh
diff options
context:
space:
mode:
Diffstat (limited to 'r-base/backport_r-base_to_etch.sh')
-rw-r--r--r-base/backport_r-base_to_etch.sh112
1 files changed, 112 insertions, 0 deletions
diff --git a/r-base/backport_r-base_to_etch.sh b/r-base/backport_r-base_to_etch.sh
new file mode 100644
index 0000000..644edeb
--- /dev/null
+++ b/r-base/backport_r-base_to_etch.sh
@@ -0,0 +1,112 @@
+#!/bin/bash
+
+# Script to automate building of r-base and r-recommended packages for
+# the Ubuntu release specified in file /etc/lsb-release. This script
+# should be run as root, in one way or another.
+
+# Author: Vincent Goulet <vincent.goulet@act.ulaval.ca>
+# Modified for backporting to Debian etch by
+# Johannes Ranke <jranke@uni-bremen.de>
+
+export DEBEMAIL="Johannes Ranke <jranke@uni-bremen.de>"
+
+#rm -rf r-base* r-base-core* r-mathlib*
+
+#apt-get update
+apt-get source -t unstable r-base
+cd r-base-*
+
+# Old version
+oldversion=`dpkg-parsechangelog | grep ^Version | cut -f2 -d " "`
+cranversion=$oldversion"~etchcran.1"
+
+# Add new version to changelog
+dch -v "${cranversion}" -D etch-cran -b "Backport form Debian unstable to Debian etch"
+
+# Reverts for etch:
+#
+# 1. Starting with Debian packages for R 2.6.1-2, the build dependency
+# to 'refblas3-dev|atlas3-base-dev' is changed to 'libblas-dev' to
+# use the new gfortran-built BLAS libraries. From R 2.7.0, the
+# dependency is on 'libblas-dev | libatlas-base-dev' for
+# r-base-dev.
+
+sed -i '/^Build-Depends/s/libblas-dev/refblas3-dev|atlas3-base-dev/' debian/control
+sed -i '/^Depends/s/libblas-dev | libatlas-base-dev/refblas3-dev|atlas3-base-dev/' debian/control
+dch -a "debian/control: revert Build-Depends: to 'refblas3-dev|atlas3-base-dev' and Depends: to 'refblas3-dev|atlas3-base-dev' since etch does not have the new gfortran-built BLAS libraries"
+
+# 2. Starting with Debian packages for R 2.6.2, new build dependency
+# on liblapack-dev to switch back to using Debian's Lapack rather
+# than the version supplied by R. From R 2.7.0, the dependency is
+# on 'liblapack-dev (>= 3.1.1)' for r-base and 'liblapack-dev |
+# libatlas-base-dev' for r-base-dev.
+
+sed -i '/^Build-Depends/s/liblapack-dev (>= 3.1.1), //' debian/control
+sed -i '/^Depends/s/liblapack-dev | libatlas-base-dev, //' debian/control
+ dch -a "debian/control: revert Build-Depends: and Depends: fields since we use the Lapack supplied with R"
+ sed -i '/^lapack/{
+s/lapack/\#lapack/
+a\
+# jr 24 Apr 2008 Set to =no for Debian etch
+a\lapack = --with-lapack=no
+}' debian/rules
+ dch -a "debian/rules: Accordingly, do not configure --with-lapack"
+
+# 3. Requirement for tk8.4 >= 8.4.16-2 introduced in r-base 2.6.0-4 to
+# circumvent a breakage with 8.4.16-1. The version in etch is 8.4.12-1etch2.
+
+rm debian/shlibs.local
+dch -a "delete debian/shlibs.local since the dependency on tk8.4 is not an issue for Debian etch"
+
+# 4. The TeX distribution in etch is tetex
+
+sed -i '/^Build-Depends/s/texlive-base, texlive-latex-base, texlive-generic-recommended, texlive-fonts-recommended, texlive-extra-utils, texlive-latex-recommended, texlive-latex-extra, texinfo, texi2html/tetex-bin, tetex-extra/' debian/control
+dch -a "debian/control: revert Build-Depends: to 'tetex-bin, tetex-extra' since etch does not have texlive"
+
+# 5. xauth is part of xbase-clients in etch
+
+sed -i '/^Build-Depends/s/xauth/xbase-clients/' debian/control
+dch -a "debian/control: replace xauth by xbase-clients in Build-Depends:"
+
+# 6. Tcl and TK are 8.4 on Debian etch
+
+sed -i '/^Build-Depends/s/ tcl8.5-dev/tcl8.4-dev/' debian/control
+sed -i '/^Build-Depends/s/ tk8.5-dev/tk8.4-dev/' debian/control
+dch -a "debian/control: revert build dependence for tcl/tk to 8.4"
+
+# 7. Openjdk is not in etch
+
+sed -i '/^Build-Depends/s/, openjdk-6-jdk \[!arm !hppa !kfreebsd-i386 !kfreebsd-amd64 !hurd-i386\]//' debian/control
+dch -a "debian/control: Remove build dependence on openjdk"
+
+# 8. R 2.9.0 wants debhelper >= 7.0.0, which is not in etch
+
+sed -i '/^Build-Depends/s/debhelper (>= 7.0.0)/debhelper/' debian/control
+dch -a "debian/control: revert Build-Depends: to 'debhelper' since etch has a version < 7.0.0"
+sed -i 's/dh_prep/dh_clean/g' debian/rules
+dch -a "debian/rules: revert dh_prep calls to dh_clean calls since the latter is not present in this release's version of 'debhelper'"
+echo 5 > debian/compat
+dch -a "debian/compat: revert 'debhelper' compatibility level to 5"
+
+# 9. R 2.9.0 wants ucf >= 3.0 which is not available in etch (2.0020)
+
+sed -i 's/ucf (>= 3.0)/ucf/' debian/control
+dch -a "debian/control: revert Depends: of r-base-core to 'ucf' since the version in etch is < 3.0"
+
+# Build package showing all messages and separating output to build and error logs
+(dpkg-buildpackage -tc | tee ../build_log_r-base_i386) 3>&1 1>&2 2>&3 | tee ../build_errors_r-base_i386
+if [ $? -ne 0 ]; then
+ exit 1
+fi
+
+cd ..
+
+# Create diff to Debian unstable
+interdiff -z *.diff.gz > interdiff_to_debian_sid
+
+# Sign logs and interdiff
+for i in interdiff_to_debian_sid build_log_r-base_i386 build_errors_r-base_i386
+do
+ gpg --clearsign $i
+ mv $i.asc $i
+done

Contact - Imprint